#include "FabriqueServeurPremiers.h"
#include "ComposantServeurPremiers.h"
#include "../../StdOutilsCOM_Lib/StdCreateInstance.h"

// ----------------------------------------------------
// Implmentation des mthodes de la classe FabriqueServeurTempsQuiPasse
// (pour IUnknown)
// ----------------------------------------------------

HRESULT __stdcall FabriqueServeurPremiers::CreateInstance (IUnknown *pUnkOuter,
                                                           REFIID riid,
                                                           void **ppv)
{
   return StdCreateInstance<ComposantServeurPremiers> (pUnkOuter, riid, ppv);
}

HRESULT FabriqueServeurPremiers::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown*> (static_cast<IClassFactory *> (this));
   }
   else if (riid == IID_IClassFactory)
   {
      *ppv = static_cast<IClassFactory*> (this);
   }
   else
   {
      // traitement d'erreur
      *ppv = 0; // NULL
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

