#include "IPremierImpl.h"
#include "OutilsServeurPremiers.h"
#include <cmath>
#include <limits>

#undef max /* entrait en conflit avec std::numeric_limits<int>::max() */


HRESULT IPremierImpl::EstPremier (int Nb, boolean *retval)
{
   *retval = EntierEstPremier (Nb)? TRUE : FALSE;
   return S_OK;
}

HRESULT IPremierImpl::NiemePremier(  int Lequel, int *retval)
{
   int NombreTeste = 2; // plus petit premier
   int NbPremiers = 0;
   while (NbPremiers < Lequel && NombreTeste < std::numeric_limits<int>::max())
   {
      if (EntierEstPremier (NombreTeste))
      {
         NbPremiers ++;
         if (NbPremiers == Lequel)
         {
            *retval = NombreTeste;
            return S_OK;
         }
      }
      NombreTeste ++;
   }
   *retval = -1;
   return S_OK;
}

