#include "OutilsServeurPremiers.h"

#include <cmath>

bool EntierEstPremier (const int Nb)
{
   if (Nb < 2)
      return false;

   int EnTest = static_cast<int>(sqrt (Nb));

   while (EnTest >= 2) // plus petit diviseur intressant
   {
      if (Nb % EnTest == 0) // le nombre est divisible par EnTest
         return false;
      EnTest --;
   }

   return true; // premier, car non divisible
}
