#define _WIN32_DCOM

#include "../Commun/premier.h"
#include "../Commun/Fabriques--ServeurPremiers.h"
#include "../../StdOutilsCOM_Lib/IUnknownImpl.h"
#include "IPremierImpl.h"
#include <vector>

class ObjetAppelPremiers;

// ----------------------------------------------------
// ----------------------------------------------------
// ----------------------------------------------------
// Class ComposantServeurPremiers: implmentation encapsule
//                                 de IPremier
// ----------------------------------------------------

class ComposantServeurPremiers : virtual public IUnknownImpl,
                                 virtual public IPremierImpl,
                                 virtual public ICallFactory
{
   std::vector<ObjetAppelPremiers *> m_ObjetsCrees;
public:
   // Pour IUnknown
   unsigned long __stdcall AddRef () { return IUnknownImpl::AddRef (); }
   unsigned long __stdcall Release () { return IUnknownImpl::Release (); }
   HRESULT __stdcall QueryInterface (REFIID riid, void **ppv);

   // Pour ICallFactory
   HRESULT __stdcall CreateCall (REFIID riid,
                                 IUnknown *pCtrlUnk,
                                 REFIID riid2,
                                 IUnknown **ppv);

   // constructeur
   ComposantServeurPremiers () : IUnknownImpl ()
   {
   }

   // destructeur
   ~ComposantServeurPremiers ();
private:
};

