#ifndef FABRIQUESERVEURPREMIERS_H
#define FABRIQUESERVEURPREMIERS_H

#include "../../StdOutilsCOM_Lib/IClassFactoryImpl.h"
#include <iostream>

class ComposantServeurPremiers;

class FabriqueServeurPremiers : virtual public IClassFactoryImpl
{
public:
   // Pour IUnknown
   unsigned long __stdcall AddRef () { return IClassFactoryImpl::AddRef (); }
   unsigned long __stdcall Release () { return IClassFactoryImpl::Release (); }
   HRESULT __stdcall QueryInterface (REFIID riid, void **ppv);

   // Pour IClassFactory
   HRESULT __stdcall CreateInstance (IUnknown *pUnkOuter,
                                     REFIID riid,
                                     void **ppv);
   HRESULT __stdcall LockServer (BOOL Verrou) { return IClassFactoryImpl::LockServer (Verrou); }

   // constructeur
   FabriqueServeurPremiers () : IClassFactoryImpl ()
   {
   }

   // destructeur
   ~FabriqueServeurPremiers ()
   {
   }
};

#endif // !defined FABRIQUESERVEURPREMIERS_H
